'
' Copyright (c) 2006 Andy Hume
' Free for all usage.
'

Imports System
Imports System.Windows.Forms
Imports System.ComponentModel   'e.g. BackgroundWorker
Imports System.Drawing  ' e.g. Point
Imports System.IO

Imports Brecham.Obex
Imports Brecham.Obex.Objects

Imports InTheHand.Net.Sockets
Imports Brecham.Obex.Net


Namespace FolderExplorerVb
   Public Class Program
      <STAThread> _
      Public Shared Sub Main()
         Application.EnableVisualStyles
         Application.SetCompatibleTextRenderingDefault(False)
         Application.Run(New Form1)
      End Sub
   End Class


   Public Class Form1
      Inherits Form

      ' Fields
      Private backgroundWorkerFillCurrentFolder As BackgroundWorker
      Private buttonConnect As Button
      Private buttonFill As Button
      Private components As IContainer
      Private listBoxFiles As ListBox
      Private listBoxFolders As ListBox
      Private m_conn As GuiObexSessionConnection
      Private radioButtonBt As RadioButton
      Private radioButtonIrda As RadioButton
      Private statusStrip1 As StatusStrip
      Private toolStripStatusLabel1 As ToolStripStatusLabel

      Private Const FolderParentName As String = ".."

      ' Constructor
      Public Sub New()
         Me.InitializeComponent
      End Sub

      ' Methods
      Private Sub InitializeComponent()
         Me.listBoxFolders = New ListBox
         Me.listBoxFiles = New ListBox
         Me.backgroundWorkerFillCurrentFolder = New BackgroundWorker
         Me.buttonConnect = New Button
         Me.buttonFill = New Button
         Me.statusStrip1 = New StatusStrip
         Me.toolStripStatusLabel1 = New ToolStripStatusLabel
         Me.radioButtonIrda = New RadioButton
         Me.radioButtonBt = New RadioButton
         Me.statusStrip1.SuspendLayout
         MyBase.SuspendLayout
         '
         Me.listBoxFolders.Anchor = (AnchorStyles.Left Or (AnchorStyles.Bottom Or AnchorStyles.Top))
         Me.listBoxFolders.FormattingEnabled = True
         Me.listBoxFolders.Location = New Point(12, 39)
         Me.listBoxFolders.Name = "listBoxFolders"
         Me.listBoxFolders.Size = New Size(133, 264)
         Me.listBoxFolders.TabIndex = 5
         AddHandler Me.listBoxFolders.DoubleClick, New EventHandler(AddressOf Me.listBoxFolders_DoubleClick)
         '
         Me.listBoxFiles.Anchor = (AnchorStyles.Right Or (AnchorStyles.Left Or (AnchorStyles.Bottom Or AnchorStyles.Top)))
         Me.listBoxFiles.FormattingEnabled = True
         Me.listBoxFiles.Location = New Point(151, 39)
         Me.listBoxFiles.Name = "listBoxFiles"
         Me.listBoxFiles.Size = New Size(263, 264)
         Me.listBoxFiles.TabIndex = 6
         AddHandler Me.listBoxFiles.DoubleClick, New EventHandler(AddressOf Me.listBoxFiles_DoubleClick)
         '
         Me.backgroundWorkerFillCurrentFolder.WorkerReportsProgress = True
         AddHandler Me.backgroundWorkerFillCurrentFolder.DoWork, New DoWorkEventHandler(AddressOf Me.backgroundWorkerFillCurrentFolder_DoWork)
         AddHandler Me.backgroundWorkerFillCurrentFolder.RunWorkerCompleted, New RunWorkerCompletedEventHandler(AddressOf Me.backgroundWorkerFillCurrentFolder_RunWorkerCompleted)
         AddHandler Me.backgroundWorkerFillCurrentFolder.ProgressChanged, New ProgressChangedEventHandler(AddressOf Me.backgroundWorkerFillCurrentFolder_ProgressChanged)
         '
         Me.buttonConnect.Location = New Point(141, 9)
         Me.buttonConnect.Name = "buttonConnect"
         Me.buttonConnect.Size = New Size(75, 23)
         Me.buttonConnect.TabIndex = 3
         Me.buttonConnect.Text = "&Connect..."
         Me.buttonConnect.UseVisualStyleBackColor = True
         AddHandler Me.buttonConnect.Click, New EventHandler(AddressOf Me.buttonConnect_Click)
         '
         Me.buttonFill.Location = New Point(339, 10)
         Me.buttonFill.Name = "buttonFill"
         Me.buttonFill.Size = New Size(75, 23)
         Me.buttonFill.TabIndex = 4
         Me.buttonFill.Text = "&Refresh"
         Me.buttonFill.UseVisualStyleBackColor = True
         AddHandler Me.buttonFill.Click, New EventHandler(AddressOf Me.buttonFill_Click)
         '
         Me.statusStrip1.Items.AddRange(New ToolStripItem() { Me.toolStripStatusLabel1 })
         Me.statusStrip1.Location = New Point(0, 310)
         Me.statusStrip1.Name = "statusStrip1"
         Me.statusStrip1.Size = New Size(426, 22)
         Me.statusStrip1.TabIndex = 4
         Me.statusStrip1.Text = "statusStrip1"
         '
         Me.toolStripStatusLabel1.Name = "toolStripStatusLabel1"
         Me.toolStripStatusLabel1.Size = New Size(109, 17)
         Me.toolStripStatusLabel1.Text = ""
         '
         Me.radioButtonBt.AutoSize = True
         Me.radioButtonBt.Checked = True
         Me.radioButtonBt.Location = New Point(65, 13)
         Me.radioButtonBt.Name = "radioButtonBt"
         Me.radioButtonBt.Size = New Size(70, 17)
         Me.radioButtonBt.TabIndex = 2
         Me.radioButtonBt.TabStop = True
         Me.radioButtonBt.Text = "&Bluetooth"
         Me.radioButtonBt.UseVisualStyleBackColor = True
         Me.radioButtonBt.Checked = True
         '
         Me.radioButtonIrda.AutoSize = True
         Me.radioButtonIrda.Location = New Point(12, 12)
         Me.radioButtonIrda.Name = "radioButtonIrda"
         Me.radioButtonIrda.Size = New Size(46, 17)
         Me.radioButtonIrda.TabIndex = 1
         Me.radioButtonIrda.TabStop = False
         Me.radioButtonIrda.Text = "&IrDA"
         Me.radioButtonIrda.UseVisualStyleBackColor = True
         '
         MyBase.AutoScaleDimensions = New SizeF(6F, 13F)
         MyBase.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
         MyBase.ClientSize = New Size(426, 332)
         MyBase.Controls.Add(Me.radioButtonBt)
         MyBase.Controls.Add(Me.radioButtonIrda)
         MyBase.Controls.Add(Me.statusStrip1)
         MyBase.Controls.Add(Me.buttonFill)
         MyBase.Controls.Add(Me.buttonConnect)
         MyBase.Controls.Add(Me.listBoxFiles)
         MyBase.Controls.Add(Me.listBoxFolders)
         MyBase.Name = "Form1"
         Me.Text = "FolderExplorerVb"
         Me.statusStrip1.ResumeLayout(False)
         Me.statusStrip1.PerformLayout
         MyBase.ResumeLayout(False)
         MyBase.PerformLayout
      End Sub


      Private Sub buttonConnect_Click(ByVal sender As Object, ByVal e As EventArgs)
         ' Connect
         Me.listBoxFolders.Items.Clear
         Me.listBoxFiles.Items.Clear
         Dim toBluetooth As Boolean
         If Me.radioButtonIrda.Checked Then
            toBluetooth = False
         ElseIf Me.radioButtonBt.Checked Then
            toBluetooth = True
         Else
            System.Diagnostics.Debug.Fail("unknown Protocol radiobutton")
            Return
         End If
         MyBase.UseWaitCursor = True
         Me.m_conn = New GuiObexSessionConnection(toBluetooth, True, Me.toolStripStatusLabel1)
         Dim connected As Boolean = Me.m_conn.Connect
         MyBase.UseWaitCursor = False
         ' Fill from the folder-listing.
         If connected Then
            Me.FillFromCurrentFolder
         End If
      End Sub

  
      Private Sub buttonFill_Click(ByVal sender As Object, ByVal e As EventArgs)
         Me.FillFromCurrentFolder
      End Sub


      Private Sub FillFromCurrentFolder()
         MyBase.UseWaitCursor = True
         Me.listBoxFolders.Items.Clear
         Me.listBoxFiles.Items.Clear
         Me.backgroundWorkerFillCurrentFolder.RunWorkerAsync
      End Sub


      Private Sub listBoxFolders_DoubleClick(ByVal sender As Object, ByVal e As EventArgs)
         Dim folderName As String = CStr(Me.listBoxFolders.SelectedItem)
         If (folderName Is "..") Then
            Me.m_conn.ObexClientSession.SetPathUp
         Else
            Me.m_conn.ObexClientSession.SetPath(folderName)
         End If
         Me.FillFromCurrentFolder
      End Sub


      Private Sub listBoxFiles_DoubleClick(ByVal sender As Object, ByVal e As EventArgs)
         Dim text1 As String = CStr(Me.listBoxFiles.SelectedItem)
         Dim stream1 As ObexGetStream = Me.m_conn.ObexClientSession.Get(text1, Nothing)
         Dim stream2 As New FileStream(text1, FileMode.Create, FileAccess.Write)
         Dim result1 As DialogResult = New Form2(stream1, stream2, Me.m_conn).ShowDialog(Me)
      End Sub

 
      ' BackgroundWorker's methods
      Private Sub backgroundWorkerFillCurrentFolder_DoWork(ByVal sender As Object, ByVal e As DoWorkEventArgs)
         Dim stream As ObexGetStream = Me.m_conn.ObexClientSession.Get(Nothing, ObexConstant.Type.FolderListing)
         Dim parser As New ObexFolderListingParser(stream)
         Dim count As Integer = 0
         Do While True
            ' User cancelled?  (Not implemented in UI as can't test with my devices
            ' as no listing takes any time to complete).
            ' In fact the listing arrives so quickly that reading them individually
            ' and adding them individually to the listboxes may add overhead, so it
            ' might be better to simply read them all, or at least to batch them in 
            ' groups to add to the list boxes.
            If Me.backgroundWorkerFillCurrentFolder.CancellationPending Then
               e.Cancel = True
               Exit Do
            End If
            Dim item As ObexFolderListingItem = parser.GetNextItem
            ' Done last item?
            If (item Is Nothing) Then
               Exit Do
            End If
            Me.backgroundWorkerFillCurrentFolder.ReportProgress(0, item)
            count += 1
         Loop
         e.Result = count
      End Sub

      ' The worker thread passes us a folder-listing item, add it to the 
      ' respective list box.
      ' Is this a little hacky?  Using the ReportProgress to do actual work, well
      ' it handles the worker thread to UI thread transition for us...
      Private Sub backgroundWorkerFillCurrentFolder_ProgressChanged(ByVal sender As Object, ByVal e As ProgressChangedEventArgs)
         ' Get the folder-listing item passed from the worker thread, and do 
         ' a preliminary cast to ensure that its of the correct type.
         Dim objItem As ObexFolderListingItem = CType(e.UserState, ObexFolderListingItem)
         ' For the three types of folder-listing item do a different action.
         If (objItem.GetType Is GetType(ObexParentFolderItem)) Then
            Me.listBoxFolders.Items.Insert(0, "..")
         ElseIf (objItem.GetType Is GetType(ObexFolderItem)) Then
            Dim fi As ObexFolderItem = DirectCast(objItem, ObexFolderItem)
            Me.listBoxFolders.Items.Add(fi.Name)
         ElseIf (objItem.GetType Is GetType(ObexFileItem)) Then
            Dim fi As ObexFileItem = DirectCast(objItem, ObexFileItem)
            Me.listBoxFiles.Items.Add(fi.Name)
         End If
      End Sub

      Private Sub backgroundWorkerFillCurrentFolder_RunWorkerCompleted(ByVal sender As Object, ByVal e As RunWorkerCompletedEventArgs)
         MyBase.UseWaitCursor = False
         Dim count As Integer = CInt(e.Result)
         If (e.Cancelled) Then
            Me.toolStripStatusLabel1.Text = ("Listing was cancelled after " & count & " items.")
         Else
            Me.toolStripStatusLabel1.Text = ("Listing contained " & count & " items.")
         End If
      End Sub


      Protected Overrides Sub Dispose(ByVal disposing As Boolean)
         If (disposing AndAlso (Not Me.components Is Nothing)) Then
            Me.components.Dispose
         End If
         MyBase.Dispose(disposing)
      End Sub


	End Class
	
	
	'===========================================================================
	Public Class Form2
      Inherits Form

      ' Methods
      Public Sub New(ByVal getStream As ObexGetStream, ByVal destStream As Stream, ByVal conn As ObexSessionConnection)
         Me.components = Nothing
         Me.InitializeComponent
         Me.m_getStream = getStream
         Me.m_destStream = destStream
         Me.m_conn = conn
      End Sub

 
   Private Sub backgroundWorkerFileDownload_DoWork(ByVal sender As Object, ByVal e As DoWorkEventArgs)
      Dim buffer As Byte() = New Byte(1024  - 1) {}
      Me.label1.Text = "Receiving GET content..."
      Dim args As FileDownloadArgs = DirectCast(e.Argument, FileDownloadArgs)
      Try 
         While (True)
            If Me.backgroundWorkerFileDownload.CancellationPending Then
                  e.Cancel = True
                  args.GetStream.Abort("User cancelled")
                  Return
            End If
            Dim length As Integer = args.GetStream.Read(buffer, 0, buffer.Length)
            If (length = 0) Then
                  Return
            End If
            args.Source.Write(buffer, 0, length)
            ' No source (GetStream) Length (yet), so can't do progress reporting!
         End While
      Finally
            args.GetStream.Close
            args.Source.Close
      End Try
   End Sub

   ' Update the progress bar on the UI thread
   Private Sub backgroundWorkerFileDownload_ProgressChanged(ByVal sender As Object, ByVal e As ProgressChangedEventArgs)
      Console.Write(("" & e.ProgressPercentage & "% "))
      Me.progressBar1.Value = e.ProgressPercentage
   End Sub

   Private Sub backgroundWorkerFileDownload_RunWorkerCompleted(ByVal sender As Object, ByVal e As RunWorkerCompletedEventArgs)
      Me.progressBar1.Visible = False ' As it's marquee/continuous style.
      Me.label2.Visible = False
      If e.Cancelled Then
            Me.label1.Text = "Cancelled"
            MessageBox.Show("Cancelled")
            MyBase.DialogResult = System.Windows.Forms.DialogResult.Cancel
      Else
            Dim obj1 As Object = e.Result
            Me.label1.Text = "Complete"
            MessageBox.Show("Complete")
            Me.buttonCancel.Text = "Close"
            MyBase.AcceptButton = Me.buttonCancel
            MyBase.CancelButton = Nothing
            Me.m_completedSuccessfully = True
      End If
   End Sub

 
   Private Sub buttonCancel_Click(ByVal sender As Object, ByVal e As EventArgs)
      If Me.m_completedSuccessfully Then
            MyBase.DialogResult = System.Windows.Forms.DialogResult.OK
      Else
            Me.backgroundWorkerFileDownload.CancelAsync
      End If
   End Sub

   Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      If (disposing AndAlso (Not Me.components Is Nothing)) Then
            Me.components.Dispose
      End If
      MyBase.Dispose(disposing)
   End Sub

   Private Sub Form2_Load(ByVal sender As Object, ByVal e As EventArgs)
      Me.backgroundWorkerFileDownload.RunWorkerAsync(New FileDownloadArgs(Me.m_getStream, Me.m_destStream, Me.m_conn))
   End Sub

 
   Private Sub InitializeComponent()
      Me.label1 = New Label
      Me.label2 = New Label
      Me.progressBar1 = New ProgressBar
      Me.buttonCancel = New Button
      Me.backgroundWorkerFileDownload = New BackgroundWorker
      MyBase.SuspendLayout
      '
      Me.label1.AutoSize = True
      Me.label1.Location = New Point(12, 9)
      Me.label1.Name = "label1"
      Me.label1.Size = New Size(43, 13)
      Me.label1.TabIndex = 0
      Me.label1.Text = "Saving:"
      '
      Me.label2.AutoSize = True
      Me.label2.Location = New Point(12, 31)
      Me.label2.Name = "label2"
      Me.label2.Size = New Size(200, 13)
      Me.label2.TabIndex = 1
      Me.label2.Text = "Don't know the GET size, so no real progress bar yet."
      '
      Me.progressBar1.Anchor = (AnchorStyles.Right Or (AnchorStyles.Left Or AnchorStyles.Top))
      Me.progressBar1.Location = New Point(12, 47)
      Me.progressBar1.Name = "progressBar1"
      Me.progressBar1.Size = New Size(268, 23)
      Me.progressBar1.Style = System.Windows.Forms.ProgressBarStyle.Marquee
      Me.progressBar1.TabIndex = 2
      '
      Me.buttonCancel.Location = New Point(204, 77)
      Me.buttonCancel.Name = "buttonCancel"
      Me.buttonCancel.Size = New Size(75, 23)
      Me.buttonCancel.TabIndex = 3
      Me.buttonCancel.Text = "Cancel"
      Me.buttonCancel.UseVisualStyleBackColor = True
      AddHandler Me.buttonCancel.Click, New EventHandler(AddressOf Me.buttonCancel_Click)
      '
      Me.backgroundWorkerFileDownload.WorkerReportsProgress = True
      Me.backgroundWorkerFileDownload.WorkerSupportsCancellation = True
      AddHandler Me.backgroundWorkerFileDownload.DoWork, New DoWorkEventHandler(AddressOf Me.backgroundWorkerFileDownload_DoWork)
      AddHandler Me.backgroundWorkerFileDownload.RunWorkerCompleted, New RunWorkerCompletedEventHandler(AddressOf Me.backgroundWorkerFileDownload_RunWorkerCompleted)
      AddHandler Me.backgroundWorkerFileDownload.ProgressChanged, New ProgressChangedEventHandler(AddressOf Me.backgroundWorkerFileDownload_ProgressChanged)
      '
      MyBase.AutoScaleDimensions = New SizeF(6!, 13!)
      MyBase.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
      MyBase.ClientSize = New Size(292, 111)
      MyBase.Controls.Add(Me.buttonCancel)
      MyBase.Controls.Add(Me.progressBar1)
      MyBase.Controls.Add(Me.label2)
      MyBase.Controls.Add(Me.label1)
      MyBase.Name = "Form2"
      MyBase.StartPosition = FormStartPosition.CenterParent
      Me.Text = "File Download"
      AddHandler MyBase.Load, New EventHandler(AddressOf Me.Form2_Load)
      MyBase.ResumeLayout(False)
      MyBase.PerformLayout
   End Sub

 

      ' Fields
      Private backgroundWorkerFileDownload As BackgroundWorker
      Private buttonCancel As Button
      Private components As IContainer
      Private label1 As Label
      Private label2 As Label
      Private m_completedSuccessfully As Boolean
      Private m_conn As ObexSessionConnection
      Private m_destStream As Stream
      Private m_getStream As ObexGetStream
      Private progressBar1 As ProgressBar

      ' Nested Types
      Private Class FileDownloadArgs
            ' Methods
		   Public Sub New(ByVal getStream As ObexGetStream, ByVal source As Stream, ByVal conn As ObexSessionConnection)
			  If (getStream Is Nothing) Then
					Throw New ArgumentNullException("putStream")
			  End If
			  If (source Is Nothing) Then
					Throw New ArgumentNullException("source")
			  End If
			  If (conn Is Nothing) Then
					Throw New ArgumentNullException("conn")
			  End If
			  Me.m_getStream = getStream
			  Me.m_source = source
			  Me.m_connection = conn
		   End Sub

 

            ' Properties
            Public ReadOnly Property Connection As ObexSessionConnection
            Get
                  Return Me.m_connection
            End Get
            End Property

            Public ReadOnly Property GetStream As ObexGetStream
            Get
                  Return Me.m_getStream
            End Get
            End Property

            Public ReadOnly Property Source As Stream
            Get
                  Return Me.m_source
            End Get
            End Property

            ' Fields
            Private ReadOnly m_connection As ObexSessionConnection
            Private ReadOnly m_getStream As ObexGetStream
            Private ReadOnly m_source As Stream
      End Class
   End Class

 

End Namespace
