

Option Strict
Option Explicit

Imports System
Imports System.IO	'e.g. FileStream, FilMode, etc.

Imports Brecham.Obex

Imports InTheHand.Net           'e.g. IrDAEndPoint
Imports InTheHand.Net.Sockets   'e.g. IrDAClient
' Available from http://32feet.net/.


Class VbPutSampleSample
        Public Shared Sub Main_SimpleNoErrorHandling(ByVal args() As String)
            ' Open file as selected by the user
            If args.Length <> 1 Then
				Console.WriteLine("No filename given.")
				Exit Sub
			End If
			Dim filename As String = args(0)
            Dim srcFile As New FileStream(filename, FileMode.Open, FileAccess.Read)
            ' Connect
            Dim cli As New IrDAClient("OBEX")
			Dim sess As New ObexClientSession(cli.GetStream, 4096)
			sess.Connect
			' And Send
			Dim name As String = Path.GetFilename(filename)
			Dim contentLength As Int64 = srcFile.Length
			sess.PutFrom(srcFile, name, Nothing, contentLength)
			cli.Close
        End Sub
End Class


Class VbPutSample
        Public Shared Sub Main(ByVal args() As String)
            '--------------------------------------------
            ' Open file as selected by the user
            '--------------------------------------------
            If args.Length <> 1 Then
				Console.WriteLine("No filename given.")
				Exit Sub
			End If
			Dim filename As String = args(0)
            Dim srcFile As New FileStream(filename, FileMode.Open, FileAccess.Read)
            
            '--------------------------------------------
            ' Create client object and connect.
            '--------------------------------------------
            Dim cli As IrDAClient
            Try
				cli = New IrDAClient("OBEX")
            Catch iopEx As InvalidOperationException
				Console.WriteLine("No peer IrDA device found.")
				Exit Sub
            Catch sEx As System.Net.Sockets.SocketException
				Console.WriteLine("IrDA connect failed: " + sEx.Message)
				Exit Sub
            End Try

            '--------------------------------------------
			' Ensure we close the connection.
            '--------------------------------------------
            Try

				'--------------------------------------------
				' Create the OBEX session object and send a Connect.
				'--------------------------------------------
				Dim sess As New ObexClientSession(cli.GetStream, 4096)
				sess.Connect
	            
				'--------------------------------------------
				' Now send the file's contents
				'--------------------------------------------
				Dim name As String = Path.GetFilename(filename)
				Dim contentLength As Int64 = srcFile.Length
				Try
					sess.PutFrom(srcFile, name, Nothing, contentLength)
				Catch orEx As ObexResponseException
					Console.WriteLine("Put failed with: " + orEx.Message)
				End Try
				Console.WriteLine("File sent.")
            
            '--------------------------------------------
            ' Clean up
            '--------------------------------------------
            Finally
				cli.Close
			End Try
            
            '--------------------------------------------
        End Sub
        
End Class
